// механику показа картинки фрейма содержит этот вспомогательный класс

// slider_height передаётся для того, чтобы можно было позиционировать текстовый блок по вертикали
var Shower = function ($wimages, slider_height) {

    // ссылка на дивы, в которых отрисовываются картинки
    // изначально оба дива приходят "чистыми"
    // В таком случае: берём первый попавшийся див , помещаем в него картинку, делаем его "показанным сейчас"
    var _$wimages = $wimages;

    // после первого вызова show(), когда дивы перестают быть "чистыми", эта переменная сбросится в false
    // нужна для того, чтобы при первом вызове взять первый попавшийся див и сделать его "показанным сейчас"
    var _mark_first_call = true;

    //slider_height передаётся для того, чтобы можно было позиционировать текстовый блок по вертикали
    var _slider_height = slider_height;

    // низкоуровневый механизм показа картинки с подписями (вызывается только из this.show)
    var _fShow = function ($div, url, props) {
        console.log("<shower._fShow>\t div class:" + $div.attr('class') + ", url: " + url);

        // убираем плавность, возвращаем в начальное состояние
        $div.removeClass('eased').css('opacity','0');

        // помещаем в него картинку
        $div.css('background-image', 'url('+url+')');

        // находим блок с текстом, фиксируем h4 и p
        var $div_text = $div.find('.frame_text');
        var $h4 = $div_text.find('h4');
        var $p = $div_text.find('p');

        // рассчитаем кое-какие размеры
        var div_text_height = $div_text.outerHeight();
        var div_text_width = $div_text.outerWidth();

        // подставляем туда текст из props
        $h4.text(props['h4']);
        $p.text(props['p']);

        // позиционируем $div_text блок с текстом по вертикали по центру относительно высоты родителя _slider_height
        var top = (_slider_height - div_text_height) / 2;
        $div_text.css('top', top + 'px');

        // ---- позиционируем прямоугольники

        // выбираем логическую середину (допустим сдвиг вверх\вниз на десяток-другой процентов от div_text_height)
        var div_text_middle = div_text_height/2 - div_text_height * .1;

        // заголовок фрейма находится в верхней половине фрейма
        var $h4_wrapper = $h4.parent();
        $h4_wrapper.css('bottom', div_text_middle);

        // заголовок фрейма чуть меньше ширины $div_text блока
        var h4_wrapper_width = div_text_width * 0.6;
        $h4_wrapper.css('width', h4_wrapper_width + 'px');

        // заголовок фрейма центрируем относительно $div_text
        var h4_wrapper_left = (div_text_width - h4_wrapper_width)/2;
        $h4_wrapper.css('left', h4_wrapper_left + 'px');

        // мелкую надпись размещаем в нижней половине прямоугольника
        $p.css('margin-top', (div_text_height - div_text_middle) + 15 + 'px');

        // ---- end позиционируем прямоугольники

        // плавно проявляем фрейм
        $div.addClass('eased').css('opacity','1');

        // помечаем его как "показанный сейчас"
        $div.addClass('shown_right_now');

    };

    // низкоуровневый механизм плавного сокрытия картинки (вызывается только из this.hide)
    var _fHide = function ($div) {
        console.log("<shower._fHide>\t div class: " + $div.attr('class'));

        // плавно скрываем фрейм
        $div.css('opacity', '0');

        // удаляем пометку "показанный сейчас" у фрейма
        $div.removeClass('shown_right_now');

    };

    // плавно показать картинку url
    // Этот метод зафиксирован в маршруте "Показать Картинку"
    // диаграммы d:\Distrs\drakon\drakon_editor1.27\work\vapehub\slider.drn
    this.show = function (url, props) {

        // если это первый вызов show() - сбрасываем переменную _mark_first_call, берем первый див и делаем его "показанным сейчас"
        if (_mark_first_call) {
            console.log("<shower.show>\t Первый вызов.");

            _mark_first_call = false;

            // фиксируем first image
            var $fi = $(_$wimages[0]);

            // покажем картинку с подписями
            _fShow($fi, url, props);

        }

        // если это не первый вызов show() - значит какой-то фрейм уже показан
        //
        else {
            console.log("<shower.show>\t НЕ-первый вызов.");

            // фиксируем показанный фрейм (shown image)
            var $si = _$wimages.filter('.shown_right_now');

            // фиксируем спрятанный фрейм (hidden image)
            var $hi = _$wimages.not('.shown_right_now');

            // прячем показанный фрейм
            _fHide($si);

            // показываем спрятанный фрейм
            _fShow($hi, url, props);

        }

    }

};