'use strict';

// 01. позволяет создавать слайдеры, главной особенностью которых является картинка фрейма, которая
// отображается с помощью css свойства background-image и с применением background-size: cover

// 02. Чтобы код применился

var Wslider = function (options) {

    // добавлена для того, чтобы передавать ссылку на wslider находясь внутри вложенных функций
    var _this = this;

    // по этим параметрам отрисован слайдер
    var _options = {
        parent_node: 'body',
        height: 100
    };

    // здесь содержится список урлов картинок, которые надо отобразить в слайдере
    var _images = null;

    // здесь содержится список описаний каждой картинки: h4 - крупный текст и p - мелкий
    var _frames_props = null;

    // указатель на текущий фрейм
    var _current_frame = 0;

    // контейнер, в который упакован слайдер
    var _$wrapper = null;

    // 2 дива, в которых отрисовываются картинки
    var _$wimages = null;

    // в ответе за загрузку и показ картинок фрейма
    // во время загрузки покажет прелодаер
    var _wloader = null;

    // код кнопок next\prev сконцентрирован тут
    var _buttons = null;

    //------------------------------------------------------------------------------------------------------------------

    // инициализация
    var _fInit = function (options) {

        // акуализируем параметры слайдера
        _options = $.extend(_options, options);

        // зафиксируем контейнер и див с картинкой
        _$wrapper = $(_options.parent_node).find('.wslider_wrapper');
        _$wimages = _$wrapper.find('div.wimage');
        //console.log(_$wimages);

        // зафиксируем список картинок для отображения
        _images = _$wrapper.data('images');

        // зафиксируем массив свойств картинок (текстовые подписи фреймов), разложенные в том же порядке что и _images
        _frames_props = _$wrapper.data('props');

        // зададим высоту картинок
        _$wimages.css('height', _$wrapper.data('height') + "px");

        // инициализация механизма загрузки и показа картинок
        _wloader = new Wloader(
            _images,
            _frames_props,
            _$wimages,
            _$wrapper.data('height'),
            _$wrapper
        );

        // инициализация кнопок next\prev
        _buttons = new PButtons(
            _$wrapper.find('div.pbuttons'),
            _$wrapper.data('height'),
            _onPbuttonClick
        );

    };

    // запускаем приложение
    var _fStart = function () {
        _wloader.checkAndShowFrame(_current_frame);
    };

    //--[ контроллер: слушает клики, меняет переменную _current_frame ]-------------------------------------------------

    var _onPbuttonClick = function (clickd_button) {
        console.log("<wslider._onPbuttonClick>\t Нажали кнопку перемотки: clickd_button = " + clickd_button); // => prev или next

        switch (clickd_button) {

            case 'prev':
                _fPrevFrame();
            break;

            case 'next':
                _fNextFrame();
            break;

        }
    };

    var _fNextFrame = function () {
        _current_frame += 1;
        if (_current_frame >= _images.length) {
            _current_frame = 0;
        }
        //console.log("<wslider._fNextFrame> _current_frame = " + _current_frame);
        _wloader.checkAndShowFrame(_current_frame);
    };

    var _fPrevFrame = function () {
        _current_frame -= 1;
        if (_current_frame < 0) {
            _current_frame = _images.length-1;
        }
        //console.log("<wslider._fPrevFrame> _current_frame = " + _current_frame);
        _wloader.checkAndShowFrame(_current_frame);
    };

    //------------------------------------------------------------------------------------------------------------------

    _fInit(options);
    _fStart();

};